function [ concentration ] = Distribution(x, Seramis, S, D, gamma, a0, R0 )
%x=[x,y,z]' ; Seramis= [ [x1 y1 z1] [x2 y2 z2] ...]
%The function generates a second layer of seramis (it mirrors the actual
%Seramis at the surface) and calculates the concentration at a given point
%x. To allow vectorized input, there is the function "DistrIntegrInter.m".

SeramisCount=size(Seramis,2);
fsGdD=-sqrt(gamma/D);%Factor: Minus root of gamma divided by D

%Special threatment 
concentrationStart=S;
if gamma~=0
    concentrationStart= S .*sqrt(D/gamma).* exp(sqrt(gamma/D).* x(3));
end
%disp(num2str(concentrationStart));
concentration=0;
for i=1:SeramisCount;
dist=norm(x-Seramis(:,i),2);               %Distance: x-Seramis
distM= norm(x-[1 1 -1]'.*Seramis(:,i),2);  %Distance: x - Mirrored-Seramis
Mval=M(i, Seramis, D, S, R0, gamma,a0 );
concentration=Mval.*(   1./dist  .*exp(fsGdD .*dist )...
                  +     1./distM .*exp(fsGdD .*distM))...
                  +concentration;
%Factor 1./(4.* pi.*D) is multiplied later
end

concentration=concentration.*1./(4.*pi.*D);
concentration=concentration+concentrationStart;
if concentration<0
    concentration=0;
end
if isinf(concentration)
    concentration=0;
end
end

