%This script initializes the parameters of the distribution 
%"Distribution.m" to integrate or plot it. The parameters and 
%parallelization is masked by an anonymous function and "DistrIntegrInter".
%The M_i factors used 

disp('start')
figure(1)
clf;
%Geometry
xmin=-2;
xmax=2;
ymin=-2;
ymax=2;
zlist=[0 -1 -1.5];
meshwidth=0.1;
xgrid=xmin:meshwidth:xmax;
ygrid=ymin:meshwidth:ymax;
xpcount=size(xgrid,2);
ypcount=size(ygrid,2);
zpcount=size(zlist,2);
grid=zeros(xpcount,ypcount,zpcount);


%Seramis (placed under the surface)
Seramis=[[0, 0, -1]'...%
        ,[1 1 -1]'...%
        ,[1 0 -1]'...%
        ,[0 1 -1]'...%
        ,[-1, 0, -1]'...%
        ,[-1 -1 -1]'...%        
        ,[0 -1 -1]'...%
        ,[1 -1 -1]'...%        
        ,[-1 1 -1]'...%
        ];
tic

%Standard initialization Data
u0=1;

D=0.021;
gamma=0.03;
a0=0.15;
R0=.2;
%Calculate the value for S (mean gradient of introduced IPU)
S=u0*sqrt(gamma/D);

%START Integal commands
%List of z-planes to integrate
zDepthList2D=[-3 -1.5 0];

%END Integral comands
%Number of tests
tests=2
for i=1:tests
disp(['test: ' num2str(i)]);

%Non standard initialization
% if i==2
%     gamma=0;
% end
if i==2
    gamma=0.03;
    Seramis=[];
end

%Integration
disp('integration')
% fun = @(x,y,z)DistrIntegrInter(x, y, z, Seramis, S, D, gamma, a0, R0 ) ;
% Q = triplequad(fun,-2,2,-2,2,-2,0)

for  zd=1:size(zDepthList2D,2)
    F = @(x,y)DistrIntegrInter(x, y, zDepthList(zd), Seramis, S, D, gamma, a0, R0 );
    Q = dblquad(F,-0.5,0.5,-0.5,0.5);
    disp(['z=' num2str(zDepthList2D(zd)) '.' 9 'Integral value: ' num2str(Q)]);
end
%Integration END


toc
disp('plot')
for zp=1:zpcount
parfor xi=1:xpcount
    for yi=1:ypcount
        %Scale the coordinates
        xp=xmin+xi*meshwidth;
        yp=ymin+yi*meshwidth;
        %Evaluate
        grid(xi,yi,zp)=Distribution([xp,yp,zlist(zp)]', Seramis, S, D, gamma, a0, R0 );
    end
end
end

%draw
for zp=1:zpcount
    subplot(zpcount,tests,(zp-1)*tests+i)
    surf(xgrid ,ygrid,grid(:,:,zp))
    axis([xmin xmax ymin ymax 0 S])
    hold on;
end
end
toc
